.TH TEEM "1" "April 2012" "Teem version 1.11.0" "User Commands"
.SH NAME
/usr/bin/teem\-puller \- Command\-line interface to the "pull" library.
.SH SYNOPSIS
.B teem-puller
[\fI@file \fR...] [\fI-int <int>\fR] [\fI-enr <spec>\fR] \fI\\fR
.SH DESCRIPTION
/usr/bin/teem\-puller: Command\-line interface to the "pull" library. Published
research using this tool or the "pull" library should cite the paper:
.IP
Gordon L. Kindlmann, Ra{\e'u}l San Jos{\e'e} Est{\e'e}par, Stephen M. Smith,
Carl\-Fredrik Westin. Sampling and Visualizing Creases with Scale\-Space
Particles. IEEE Trans. on Visualization and Computer Graphics,
15(6):1415\-1424 (2009).
.IP
[\-ens <spec>] [\-enw <spec>] [\-efs <bool>] [\-nave <bool>] [\-cbst <bool>] \e
[\-noadd] [\-usa <bool>] [\-pcet <bool>] [\-nobin] [\-lti <bool>] \e
[\-por <bool>] [\-npcwza <bool>] [\-ubfgl <bool>] [\-ratb <bool>] \e
[\-svec <vec>] [\-gssr <rad>] [\-v <verbosity>] \fB\-vol\fR <vol0 vol1 ...> \e
\fB\-info\fR <info0 info1 ...> [\-k00 <kern00>] [\-k11 <kern11>] [\-k22 <kern22>] \e
[\-sscp <path>] [\-kssb <kernel>] [\-kssr <kernel>] [\-nss <# scl smpls>] \e
[\-np <# points>] [\-halton] [\-ppv <# pnts/vox>] [\-ppvzr <z range>] \e
[\-jit <jitter>] [\-pi <npos>] [\-step <step>] [\-csm <step>] [\-snap <# \e
iters>] [\-maxi <# iters>] [\-stim <# iters>] [\-maxci <# iters>] \e
[\-irad <scale>] [\-srad <scale>] [\-bws <bin width>] [\-alpha <alpha>] \e
[\-beta <beta>] [\-gamma <gamma>] [\-theta <theta>] [\-wall <k>] [\-eip <k>] \e
[\-ess <scl>] [\-oss <scl>] [\-edmin <frac>] [\-edpcmin <frac>] \e
[\-fnnm <frac>] [\-pcp <period>] [\-iad <# iters>] [\-icb <# iters>] \e
[\-ac3c <ac3c>] [\-sit <sit>] [\-rng <seed>] [\-pbm <mod>] [\-eiphl <hl>] \e
[\-nt <# threads>] [\-nprob <prob>] [\-pprob <prob>] [\-addlog <fname>] \e
[\-o <nout>] [\-eob <base>]
.IP
@file ... = response file(s) containing command\-line arguments
.IP
\fB\-int\fR <int> = inter\-particle energy type (interaction type);
.IP
default: "justr"
.IP
\fB\-enr\fR <spec> = inter\-particle energy, radial component (energy
.IP
specification); default: "cotan"
.IP
\fB\-ens\fR <spec> = inter\-particle energy, scale component (energy
.IP
specification); default: "zero"
.IP
\fB\-enw\fR <spec> = windowing to create locality with additive
.IP
scale\-space interaction ("\-int add") (energy
specification); default: "butter:16,0.8"
.IP
\fB\-efs\fR <bool> = whether or not strength contributes to
.IP
particle\-image energy (bool); default: "false"
.IP
\fB\-nave\fR <bool> = whether or not to nix points at edge of volume,
.IP
where gage had to invent values for kernel support
(bool); default: "false"
.IP
\fB\-cbst\fR <bool> = during initialization, try constraint satisfaction
.IP
before testing seedThresh (bool); default: "false"
.IP
\fB\-noadd\fR = turn off adding during population control
.IP
\fB\-usa\fR <bool> = allow volumes to have different shapes (false is
.IP
safe as different volume sizes are often accidental)
(bool); default: "false"
.IP
\fB\-pcet\fR <bool> = use neighbor\-counting "enough" heuristic to bail out
.IP
of pop cntl (bool); default: "true"
.IP
\fB\-nobin\fR = turn off spatial binning (which prevents
.IP
multi\-threading from being useful), for debugging or
speed\-up measurement
.IP
\fB\-lti\fR <bool> = impose liveThresh on initialization (bool);
.IP
default: "true"
.IP
\fB\-por\fR <bool> = permute points during rebinning (bool);
.IP
default: "true"
.HP
\fB\-npcwza\fR <bool> = no pop cntl with zero alpha (bool); default: "false"
.HP
\fB\-ubfgl\fR <bool> = use beta for gamma learning (bool); default: "false"
.IP
\fB\-ratb\fR <bool> = be choosy when adding points to bins to avoid
.IP
overlap (bool); default: "true"
.IP
\fB\-svec\fR <vec> = if non\-zero (length), vector to use for displaying
.IP
scale in 3\-space (3 doubles); default: "0 0 0"
.IP
\fB\-gssr\fR <rad> = if non\-zero (length), scaling of scale to
.IP
cylindrical tensors (double); default: "0.0"
.HP
\fB\-v\fR <verbosity> = verbosity level (int); default: "1"
.TP
\fB\-vol\fR <vol0 vol1 ...> = input volumes, in format <filename>:<kind>:<volname>
(1 or more meetPullVols)
.PP
\fB\-info\fR <info0 info1 ...> = info definitions, in format
.IP
<info>[\-c]:<volname>:<item>[:<zero>:<scale>]
(1 or more meetPullInfos)
.TP
\fB\-k00\fR <kern00> = kernel for gageKernel00 (kernel specification);
default: "cubic:1,0"
.TP
\fB\-k11\fR <kern11> = kernel for gageKernel11 (kernel specification);
default: "cubicd:1,0"
.TP
\fB\-k22\fR <kern22> = kernel for gageKernel22 (kernel specification);
default: "cubicdd:1,0"
.IP
\fB\-sscp\fR <path> = path (without trailing /) for where to read/write
.IP
pre\-blurred volumes for scale\-space (string);
default: "./"
.TP
\fB\-kssb\fR <kernel> = blurring kernel, to sample scale space (kernel
specification); default: "ds:1,5"
.TP
\fB\-kssr\fR <kernel> = kernel for reconstructing from scale space samples
(kernel specification); default: "hermite"
.TP
\fB\-nss\fR <# scl smpls> = if using "\-ppv", number of samples along scale axis
for each spatial position (unsigned int);
default: "1"
.TP
\fB\-np\fR <# points> = number of points to start in system (unsigned int);
default: "1000"
.IP
\fB\-halton\fR = use Halton sequence initialization instead of
.IP
uniform random
.TP
\fB\-ppv\fR <# pnts/vox> = number of points per voxel to start in simulation
(need to have a seed thresh vol, overrides "\-np")
(unsigned int); default: "0"
.TP
\fB\-ppvzr\fR <z range> = range of Z slices (1st num < 2nd num) to do ppv in,
or, "1 0" for whole volume (2 unsigned ints);
default: "1 0"
.TP
\fB\-jit\fR <jitter> = amount of jittering to do with ppv (double);
default: "0"
.IP
\fB\-pi\fR <npos> = 4\-by\-N array of positions to start at (overrides
.IP
"\-np") (nrrd); default: ""
.IP
\fB\-step\fR <step> = initial step size for gradient descent (double);
.IP
default: "1"
.IP
\fB\-csm\fR <step> = convergence criterion for constraint satisfaction
.IP
(double); default: "0.0001"
.TP
\fB\-snap\fR <# iters> = if non\-zero, # iters between saved snapshots
(unsigned int); default: "0"
.TP
\fB\-maxi\fR <# iters> = if non\-zero, max # iterations to run whole system
(unsigned int); default: "0"
.TP
\fB\-stim\fR <# iters> = if non\-zero, max # iterations to allow a particle to
be stuck before nixing (unsigned int); default: "5"
.TP
\fB\-maxci\fR <# iters> = if non\-zero, max # iterations for contraint
enforcement (unsigned int); default: "15"
.TP
\fB\-irad\fR <scale> = particle radius in spatial domain (double);
default: "1"
.TP
\fB\-srad\fR <scale> = particle radius in scale domain (double);
default: "1"
.TP
\fB\-bws\fR <bin width> = spatial bin width as multiple of spatial radius
(double); default: "1.001"
.TP
\fB\-alpha\fR <alpha> = blend between particle\-image (alpha=0) and
inter\-particle (alpha=1) energies (double);
default: "0.5"
.IP
\fB\-beta\fR <beta> = when using Phi2 energy, blend between pure space
.IP
repulsion (beta=0) and scale attraction (beta=1)
(double); default: "1.0"
.TP
\fB\-gamma\fR <gamma> = scaling factor on energy from strength (double);
default: "1.0"
.TP
\fB\-theta\fR <theta> = slope of increasing livethresh wrt scale (double);
default: "0.0"
.IP
\fB\-wall\fR <k> = spring constant on walls (double); default: "0.0"
.IP
\fB\-eip\fR <k> = amount by which its okay for *per\-particle* energy
.IP
to increase during gradient descent process (double);
default: "0.0"
.IP
\fB\-ess\fR <scl> = when energy goes up instead of down, scale step size
.IP
by this (double); default: "0.5"
.IP
\fB\-oss\fR <scl> = opportunistic scaling (hopefully up, >1) of step
.IP
size on every iteration (double); default: "1.0"
.TP
\fB\-edmin\fR <frac> = convergence threshold: stop when fractional
improvement (decrease) in energy dips below this
(double); default: "0.0001"
.TP
\fB\-edpcmin\fR <frac> = population control is triggered when energy
improvement goes below this threshold (double);
default: "0.01"
.IP
\fB\-fnnm\fR <frac> = don't nix if this fraction (or more) of neighbors
.IP
have been nixed (double); default: "0.25"
.TP
\fB\-pcp\fR <period> = # iters to wait between attempts at population
control (unsigned int); default: "20"
.TP
\fB\-iad\fR <# iters> = # iters to run descent on tentative new points
during PC (unsigned int); default: "10"
.TP
\fB\-icb\fR <# iters> = periodicity of calling rendering callback (unsigned
int); default: "1"
.IP
\fB\-ac3c\fR <ac3c> = allow codimensions 3 constraints (bool);
.IP
default: "false"
.IP
\fB\-sit\fR <sit> = scale is tau (bool); default: "false"
.IP
\fB\-rng\fR <seed> = base seed value for RNGs (unsigned int);
.IP
default: "42"
.IP
\fB\-pbm\fR <mod> = progress bin mod (unsigned int); default: "50"
.IP
\fB\-eiphl\fR <hl> = half\-life of energyIncreasePermute ("\-eip")
.IP
(unsigned int); default: "0"
.TP
\fB\-nt\fR <# threads> = number of threads hoover should use (int);
default: "1"
.TP
\fB\-nprob\fR <prob> = do full neighbor discovery with this probability
(double); default: "1.0"
.TP
\fB\-pprob\fR <prob> = probe local image values with this probability
(double); default: "1.0"
.TP
\fB\-addlog\fR <fname> = name of file in which to log all particle additions
(string); default: ""
.IP
\fB\-o\fR <nout> = output volume (string); default: "\-"
.IP
\fB\-eob\fR <base> = save extra info (besides position), and use this
.IP
string as the base of the filenames. Not using this
means the extra info is not saved. (string);
default: ""
.SH "SEE ALSO"
The full documentation for
.B Teem
is maintained as a Texinfo manual.  If the
.B info
and
.B Teem
programs are properly installed at your site, the command
.IP
.B info Teem
.PP
should give you access to the complete manual.
